
_Init:

;electronique_chenillard_003c_16f628a.mpas,191 :: 		begin
;electronique_chenillard_003c_16f628a.mpas,193 :: 		CMCON := 7;
	MOVLW      7
	MOVWF      CMCON+0
;electronique_chenillard_003c_16f628a.mpas,196 :: 		OPTION_REG.T0CS := 0;  // bit 5 TMR0 Clock Source Select bit:0=Internal Clock (CLKO) / 1=Transition on T0CKI pin
	BCF        OPTION_REG+0, 5
;electronique_chenillard_003c_16f628a.mpas,197 :: 		OPTION_REG.T0SE := 0;  // bit 4 TMR0 Source Edge Select bit: 0=low/high / 1=high/low
	BCF        OPTION_REG+0, 4
;electronique_chenillard_003c_16f628a.mpas,198 :: 		OPTION_REG.PSA  := 1;  // bit 3 Prescaler Assignment bit: 0=Prescaler is assigned to the Timer0
	BSF        OPTION_REG+0, 3
;electronique_chenillard_003c_16f628a.mpas,199 :: 		OPTION_REG.PS2  := 0;  // bits 2-0  PS2:PS0: Prescaler Rate Select bits
	BCF        OPTION_REG+0, 2
;electronique_chenillard_003c_16f628a.mpas,200 :: 		OPTION_REG.PS1  := 0;
	BCF        OPTION_REG+0, 1
;electronique_chenillard_003c_16f628a.mpas,201 :: 		OPTION_REG.PS0  := 0;
	BCF        OPTION_REG+0, 0
;electronique_chenillard_003c_16f628a.mpas,202 :: 		TMR0 := 0;             // preset for timer register
	CLRF       TMR0+0
;electronique_chenillard_003c_16f628a.mpas,204 :: 		INTCON.GIE  := 1;
	BSF        INTCON+0, 7
;electronique_chenillard_003c_16f628a.mpas,205 :: 		INTCON.T0IE := 1;
	BSF        INTCON+0, 5
;electronique_chenillard_003c_16f628a.mpas,206 :: 		INTCON.INTE := 0;  // disable RB0 int
	BCF        INTCON+0, 4
;electronique_chenillard_003c_16f628a.mpas,207 :: 		INTCON.RBIE := 1;  // enable RB4..RB7 int
	BSF        INTCON+0, 3
;electronique_chenillard_003c_16f628a.mpas,209 :: 		TRISA       := %00010000;  // PORTA as output, but RA4 as input
	MOVLW      16
	MOVWF      TRISA+0
;electronique_chenillard_003c_16f628a.mpas,210 :: 		TRISB       := %11110000;  // RB0..RB3 as output, all other as input
	MOVLW      240
	MOVWF      TRISB+0
;electronique_chenillard_003c_16f628a.mpas,211 :: 		PORTA       := 0;  // clear porta
	CLRF       PORTA+0
;electronique_chenillard_003c_16f628a.mpas,212 :: 		PORTB       := 0;  // clear portb
	CLRF       PORTB+0
;electronique_chenillard_003c_16f628a.mpas,213 :: 		iTimerCount := 0;
	CLRF       _iTimerCount+0
	CLRF       _iTimerCount+1
;electronique_chenillard_003c_16f628a.mpas,214 :: 		ProgToUse   := Prg001a;
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg001a+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg001a+0)
	MOVWF      R0+1
	MOVLW      10
	MOVWF      R2+0
	CALL       ___CCA2AW+0
;electronique_chenillard_003c_16f628a.mpas,215 :: 		ProgIdx     := 1;
	MOVLW      1
	MOVWF      _ProgIdx+0
;electronique_chenillard_003c_16f628a.mpas,216 :: 		FigureIdx   := 0;
	CLRF       _FigureIdx+0
;electronique_chenillard_003c_16f628a.mpas,217 :: 		iSpeed      := 127;
	MOVLW      127
	MOVWF      _iSpeed+0
	CLRF       _iSpeed+1
;electronique_chenillard_003c_16f628a.mpas,218 :: 		end;
L_end_Init:
	RETURN
; end of _Init

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_chenillard_003c_16f628a.mpas,221 :: 		begin
;electronique_chenillard_003c_16f628a.mpas,222 :: 		if INTCON.T0IF then
	BTFSS      INTCON+0, 2
	GOTO       L__Interrupt3
;electronique_chenillard_003c_16f628a.mpas,224 :: 		inc(iTimerCount);
	INCF       _iTimerCount+0, 1
	BTFSC      STATUS+0, 2
	INCF       _iTimerCount+1, 1
;electronique_chenillard_003c_16f628a.mpas,225 :: 		TMR0   :=  0;
	CLRF       TMR0+0
;electronique_chenillard_003c_16f628a.mpas,226 :: 		INTCON.T0IF := 0;       // reset T0 flag
	BCF        INTCON+0, 2
;electronique_chenillard_003c_16f628a.mpas,227 :: 		end;
L__Interrupt3:
;electronique_chenillard_003c_16f628a.mpas,228 :: 		if INTCON.RBIF then
	BTFSS      INTCON+0, 0
	GOTO       L__Interrupt6
;electronique_chenillard_003c_16f628a.mpas,230 :: 		if ((PORTB.4 = 1) and (PORTA.4 = 0)) then   // Prog next
	BTFSC      PORTB+0, 4
	GOTO       L__Interrupt154
	BCF        113, 0
	GOTO       L__Interrupt155
L__Interrupt154:
	BSF        113, 0
L__Interrupt155:
	BTFSC      PORTA+0, 4
	GOTO       L__Interrupt156
	BSF        3, 0
	GOTO       L__Interrupt157
L__Interrupt156:
	BCF        3, 0
L__Interrupt157:
	BTFSS      113, 0
	GOTO       L__Interrupt158
	BTFSS      3, 0
	GOTO       L__Interrupt158
	BSF        113, 0
	GOTO       L__Interrupt159
L__Interrupt158:
	BCF        113, 0
L__Interrupt159:
	BTFSS      113, 0
	GOTO       L__Interrupt9
;electronique_chenillard_003c_16f628a.mpas,232 :: 		if ProgIdx < iProgCount then
	MOVLW      25
	SUBWF      _ProgIdx+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__Interrupt12
;electronique_chenillard_003c_16f628a.mpas,233 :: 		inc(ProgIdx)    // go to next prog
	INCF       _ProgIdx+0, 1
	GOTO       L__Interrupt13
;electronique_chenillard_003c_16f628a.mpas,234 :: 		else
L__Interrupt12:
;electronique_chenillard_003c_16f628a.mpas,235 :: 		ProgIdx := 1;   // go to first prog
	MOVLW      1
	MOVWF      _ProgIdx+0
L__Interrupt13:
;electronique_chenillard_003c_16f628a.mpas,236 :: 		end;
L__Interrupt9:
;electronique_chenillard_003c_16f628a.mpas,237 :: 		if ((PORTB.5 = 1) and (PORTA.4 = 0)) then   // Prog prev
	BTFSC      PORTB+0, 5
	GOTO       L__Interrupt160
	BCF        113, 0
	GOTO       L__Interrupt161
L__Interrupt160:
	BSF        113, 0
L__Interrupt161:
	BTFSC      PORTA+0, 4
	GOTO       L__Interrupt162
	BSF        3, 0
	GOTO       L__Interrupt163
L__Interrupt162:
	BCF        3, 0
L__Interrupt163:
	BTFSS      113, 0
	GOTO       L__Interrupt164
	BTFSS      3, 0
	GOTO       L__Interrupt164
	BSF        113, 0
	GOTO       L__Interrupt165
L__Interrupt164:
	BCF        113, 0
L__Interrupt165:
	BTFSS      113, 0
	GOTO       L__Interrupt15
;electronique_chenillard_003c_16f628a.mpas,239 :: 		if ProgIdx > 1 then
	MOVF       _ProgIdx+0, 0
	SUBLW      1
	BTFSC      STATUS+0, 0
	GOTO       L__Interrupt18
;electronique_chenillard_003c_16f628a.mpas,240 :: 		dec(ProgIdx)   // go to prev prog
	DECF       _ProgIdx+0, 1
	GOTO       L__Interrupt19
;electronique_chenillard_003c_16f628a.mpas,241 :: 		else
L__Interrupt18:
;electronique_chenillard_003c_16f628a.mpas,242 :: 		ProgIdx := iProgCount;  // go to last prog
	MOVLW      25
	MOVWF      _ProgIdx+0
L__Interrupt19:
;electronique_chenillard_003c_16f628a.mpas,243 :: 		end;
L__Interrupt15:
;electronique_chenillard_003c_16f628a.mpas,244 :: 		if PORTB.6 = 1 then           // speed up
	BTFSS      PORTB+0, 6
	GOTO       L__Interrupt21
;electronique_chenillard_003c_16f628a.mpas,246 :: 		if iSpeed > 10 then
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      _iSpeed+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt166
	MOVF       _iSpeed+0, 0
	SUBLW      10
L__Interrupt166:
	BTFSC      STATUS+0, 0
	GOTO       L__Interrupt24
;electronique_chenillard_003c_16f628a.mpas,247 :: 		iSpeed := iSpeed - 10
	MOVLW      10
	SUBWF      _iSpeed+0, 1
	BTFSS      STATUS+0, 0
	DECF       _iSpeed+1, 1
	GOTO       L__Interrupt25
;electronique_chenillard_003c_16f628a.mpas,248 :: 		else
L__Interrupt24:
;electronique_chenillard_003c_16f628a.mpas,249 :: 		iSpeed := 1;
	MOVLW      1
	MOVWF      _iSpeed+0
	CLRF       _iSpeed+1
L__Interrupt25:
;electronique_chenillard_003c_16f628a.mpas,250 :: 		end else if PORTB.7 = 1 then  // speed down
	GOTO       L__Interrupt22
L__Interrupt21:
	BTFSS      PORTB+0, 7
	GOTO       L__Interrupt27
;electronique_chenillard_003c_16f628a.mpas,252 :: 		if iSpeed < 245 then
	MOVLW      128
	XORWF      _iSpeed+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt167
	MOVLW      245
	SUBWF      _iSpeed+0, 0
L__Interrupt167:
	BTFSC      STATUS+0, 0
	GOTO       L__Interrupt30
;electronique_chenillard_003c_16f628a.mpas,253 :: 		iSpeed := iSpeed + 10
	MOVLW      10
	ADDWF      _iSpeed+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iSpeed+1, 1
	GOTO       L__Interrupt31
;electronique_chenillard_003c_16f628a.mpas,254 :: 		else
L__Interrupt30:
;electronique_chenillard_003c_16f628a.mpas,255 :: 		iSpeed := 255;
	MOVLW      255
	MOVWF      _iSpeed+0
	CLRF       _iSpeed+1
L__Interrupt31:
;electronique_chenillard_003c_16f628a.mpas,256 :: 		end;
L__Interrupt27:
L__Interrupt22:
;electronique_chenillard_003c_16f628a.mpas,257 :: 		INTCON.RBIF := 0;         //reset RB4..RB7 int flag
	BCF        INTCON+0, 0
;electronique_chenillard_003c_16f628a.mpas,258 :: 		end;
L__Interrupt6:
;electronique_chenillard_003c_16f628a.mpas,260 :: 		end;
L_end_Interrupt:
L__Interrupt153:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_GetFigure:

;electronique_chenillard_003c_16f628a.mpas,263 :: 		begin
;electronique_chenillard_003c_16f628a.mpas,266 :: 		1  : if bProgAuto then ProgToUse := Prg001a else ProgToUse := Prg001b;
	MOVF       _ProgIdx+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure36
	MOVF       _bProgAuto+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__GetFigure38
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg001a+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg001a+0)
	MOVWF      R0+1
	MOVLW      10
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure39
L__GetFigure38:
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg001b+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg001b+0)
	MOVWF      R0+1
	MOVLW      9
	MOVWF      R2+0
	CALL       ___CCA2AW+0
L__GetFigure39:
	GOTO       L__GetFigure33
L__GetFigure36:
;electronique_chenillard_003c_16f628a.mpas,267 :: 		2  : if bProgAuto then ProgToUse := Prg002a else ProgToUse := Prg002b;
	MOVF       _ProgIdx+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure42
	MOVF       _bProgAuto+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__GetFigure44
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg002a+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg002a+0)
	MOVWF      R0+1
	MOVLW      10
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure45
L__GetFigure44:
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg002b+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg002b+0)
	MOVWF      R0+1
	MOVLW      9
	MOVWF      R2+0
	CALL       ___CCA2AW+0
L__GetFigure45:
	GOTO       L__GetFigure33
L__GetFigure42:
;electronique_chenillard_003c_16f628a.mpas,268 :: 		3  : if bProgAuto then ProgToUse := Prg003a else ProgToUse := Prg003b;
	MOVF       _ProgIdx+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure48
	MOVF       _bProgAuto+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__GetFigure50
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg003a+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg003a+0)
	MOVWF      R0+1
	MOVLW      17
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure51
L__GetFigure50:
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg003b+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg003b+0)
	MOVWF      R0+1
	MOVLW      15
	MOVWF      R2+0
	CALL       ___CCA2AW+0
L__GetFigure51:
	GOTO       L__GetFigure33
L__GetFigure48:
;electronique_chenillard_003c_16f628a.mpas,269 :: 		4  : ProgToUse := Prg004;
	MOVF       _ProgIdx+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure54
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg004+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg004+0)
	MOVWF      R0+1
	MOVLW      6
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure54:
;electronique_chenillard_003c_16f628a.mpas,270 :: 		5  : ProgToUse := Prg005;
	MOVF       _ProgIdx+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure57
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg005+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg005+0)
	MOVWF      R0+1
	MOVLW      6
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure57:
;electronique_chenillard_003c_16f628a.mpas,271 :: 		6  : if bProgAuto then ProgToUse := Prg006a else ProgToUse := Prg006b;
	MOVF       _ProgIdx+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure60
	MOVF       _bProgAuto+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__GetFigure62
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg006a+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg006a+0)
	MOVWF      R0+1
	MOVLW      9
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure63
L__GetFigure62:
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg006b+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg006b+0)
	MOVWF      R0+1
	MOVLW      7
	MOVWF      R2+0
	CALL       ___CCA2AW+0
L__GetFigure63:
	GOTO       L__GetFigure33
L__GetFigure60:
;electronique_chenillard_003c_16f628a.mpas,272 :: 		7  : ProgToUse := Prg007;
	MOVF       _ProgIdx+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure66
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg007+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg007+0)
	MOVWF      R0+1
	MOVLW      14
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure66:
;electronique_chenillard_003c_16f628a.mpas,273 :: 		8  : ProgToUse := Prg008;
	MOVF       _ProgIdx+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure69
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg008+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg008+0)
	MOVWF      R0+1
	MOVLW      14
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure69:
;electronique_chenillard_003c_16f628a.mpas,274 :: 		9  : ProgToUse := Prg009;
	MOVF       _ProgIdx+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure72
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg009+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg009+0)
	MOVWF      R0+1
	MOVLW      16
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure72:
;electronique_chenillard_003c_16f628a.mpas,275 :: 		10 : ProgToUse := Prg010;
	MOVF       _ProgIdx+0, 0
	XORLW      10
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure75
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg010+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg010+0)
	MOVWF      R0+1
	MOVLW      16
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure75:
;electronique_chenillard_003c_16f628a.mpas,276 :: 		11 : if bProgAuto then ProgToUse := Prg011a else ProgToUse := Prg011b;
	MOVF       _ProgIdx+0, 0
	XORLW      11
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure78
	MOVF       _bProgAuto+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__GetFigure80
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg011a+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg011a+0)
	MOVWF      R0+1
	MOVLW      9
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure81
L__GetFigure80:
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg011b+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg011b+0)
	MOVWF      R0+1
	MOVLW      7
	MOVWF      R2+0
	CALL       ___CCA2AW+0
L__GetFigure81:
	GOTO       L__GetFigure33
L__GetFigure78:
;electronique_chenillard_003c_16f628a.mpas,277 :: 		12 : ProgToUse := Prg012;
	MOVF       _ProgIdx+0, 0
	XORLW      12
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure84
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg012+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg012+0)
	MOVWF      R0+1
	MOVLW      6
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure84:
;electronique_chenillard_003c_16f628a.mpas,278 :: 		13 : ProgToUse := Prg013;
	MOVF       _ProgIdx+0, 0
	XORLW      13
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure87
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg013+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg013+0)
	MOVWF      R0+1
	MOVLW      6
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure87:
;electronique_chenillard_003c_16f628a.mpas,279 :: 		14 : if bProgAuto then ProgToUse := Prg014a else ProgToUse := Prg014b;
	MOVF       _ProgIdx+0, 0
	XORLW      14
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure90
	MOVF       _bProgAuto+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__GetFigure92
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg014a+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg014a+0)
	MOVWF      R0+1
	MOVLW      6
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure93
L__GetFigure92:
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg014b+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg014b+0)
	MOVWF      R0+1
	MOVLW      3
	MOVWF      R2+0
	CALL       ___CCA2AW+0
L__GetFigure93:
	GOTO       L__GetFigure33
L__GetFigure90:
;electronique_chenillard_003c_16f628a.mpas,280 :: 		15 : if bProgAuto then ProgToUse := Prg015a else ProgToUse := Prg015b;
	MOVF       _ProgIdx+0, 0
	XORLW      15
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure96
	MOVF       _bProgAuto+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__GetFigure98
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg015a+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg015a+0)
	MOVWF      R0+1
	MOVLW      6
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure99
L__GetFigure98:
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg015b+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg015b+0)
	MOVWF      R0+1
	MOVLW      3
	MOVWF      R2+0
	CALL       ___CCA2AW+0
L__GetFigure99:
	GOTO       L__GetFigure33
L__GetFigure96:
;electronique_chenillard_003c_16f628a.mpas,281 :: 		16 : ProgToUse := Prg016;
	MOVF       _ProgIdx+0, 0
	XORLW      16
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure102
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg016+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg016+0)
	MOVWF      R0+1
	MOVLW      33
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure102:
;electronique_chenillard_003c_16f628a.mpas,282 :: 		17 : if bProgAuto then ProgToUse := Prg017a else ProgToUse := Prg017b;
	MOVF       _ProgIdx+0, 0
	XORLW      17
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure105
	MOVF       _bProgAuto+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__GetFigure107
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg017a+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg017a+0)
	MOVWF      R0+1
	MOVLW      29
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure108
L__GetFigure107:
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg017b+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg017b+0)
	MOVWF      R0+1
	MOVLW      25
	MOVWF      R2+0
	CALL       ___CCA2AW+0
L__GetFigure108:
	GOTO       L__GetFigure33
L__GetFigure105:
;electronique_chenillard_003c_16f628a.mpas,283 :: 		18 : ProgToUse := Prg018;
	MOVF       _ProgIdx+0, 0
	XORLW      18
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure111
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg018+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg018+0)
	MOVWF      R0+1
	MOVLW      6
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure111:
;electronique_chenillard_003c_16f628a.mpas,284 :: 		19 : ProgToUse := Prg019;
	MOVF       _ProgIdx+0, 0
	XORLW      19
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure114
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg019+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg019+0)
	MOVWF      R0+1
	MOVLW      18
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure114:
;electronique_chenillard_003c_16f628a.mpas,285 :: 		20 : ProgToUse := Prg020;
	MOVF       _ProgIdx+0, 0
	XORLW      20
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure117
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg020+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg020+0)
	MOVWF      R0+1
	MOVLW      9
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure117:
;electronique_chenillard_003c_16f628a.mpas,286 :: 		21 : ProgToUse := Prg021;
	MOVF       _ProgIdx+0, 0
	XORLW      21
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure120
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg021+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg021+0)
	MOVWF      R0+1
	MOVLW      9
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure120:
;electronique_chenillard_003c_16f628a.mpas,287 :: 		22 : ProgToUse := Prg022;
	MOVF       _ProgIdx+0, 0
	XORLW      22
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure123
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg022+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg022+0)
	MOVWF      R0+1
	MOVLW      17
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure123:
;electronique_chenillard_003c_16f628a.mpas,288 :: 		23 : ProgToUse := Prg023;
	MOVF       _ProgIdx+0, 0
	XORLW      23
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure126
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg023+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg023+0)
	MOVWF      R0+1
	MOVLW      17
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure126:
;electronique_chenillard_003c_16f628a.mpas,289 :: 		24 : ProgToUse := Prg024;
	MOVF       _ProgIdx+0, 0
	XORLW      24
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure129
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg024+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg024+0)
	MOVWF      R0+1
	MOVLW      50
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure129:
;electronique_chenillard_003c_16f628a.mpas,290 :: 		25 : ProgToUse := Prg025;
	MOVF       _ProgIdx+0, 0
	XORLW      25
	BTFSS      STATUS+0, 2
	GOTO       L__GetFigure132
	MOVLW      _ProgToUse+0
	MOVWF      FSR
	MOVLW      _Prg025+0
	MOVWF      R0+0
	MOVLW      hi_addr(_Prg025+0)
	MOVWF      R0+1
	MOVLW      49
	MOVWF      R2+0
	CALL       ___CCA2AW+0
	GOTO       L__GetFigure33
L__GetFigure132:
L__GetFigure33:
;electronique_chenillard_003c_16f628a.mpas,292 :: 		Result := ProgToUse[FigureIdx];
	MOVF       _FigureIdx+0, 0
	ADDLW      _ProgToUse+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      GetFigure_local_result+0
;electronique_chenillard_003c_16f628a.mpas,293 :: 		end;
	MOVF       GetFigure_local_result+0, 0
	MOVWF      R0+0
L_end_GetFigure:
	RETURN
; end of _GetFigure

_main:

;electronique_chenillard_003c_16f628a.mpas,296 :: 		begin
;electronique_chenillard_003c_16f628a.mpas,297 :: 		Init;
	CALL       _Init+0
;electronique_chenillard_003c_16f628a.mpas,298 :: 		while true do
L__main135:
;electronique_chenillard_003c_16f628a.mpas,300 :: 		bProgReadyToChange := (iTimerCount >= iSpeed);
	MOVLW      128
	XORWF      _iTimerCount+1, 0
	MOVWF      R0+0
	MOVLW      128
	XORWF      _iSpeed+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main170
	MOVF       _iSpeed+0, 0
	SUBWF      _iTimerCount+0, 0
L__main170:
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _bProgReadyToChange+0
;electronique_chenillard_003c_16f628a.mpas,301 :: 		if bProgReadyToChange then
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main140
;electronique_chenillard_003c_16f628a.mpas,303 :: 		bProgAuto := (PORTA.4 = 1);
	MOVLW      0
	BTFSC      PORTA+0, 4
	MOVLW      1
	MOVWF      _bProgAuto+0
	MOVF       _bProgAuto+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      _bProgAuto+0
;electronique_chenillard_003c_16f628a.mpas,304 :: 		if FigureIdx < ProgToUse[0] then
	MOVF       _ProgToUse+0, 0
	SUBWF      _FigureIdx+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main143
;electronique_chenillard_003c_16f628a.mpas,307 :: 		inc(FigureIdx); // go to next figure
	INCF       _FigureIdx+0, 1
;electronique_chenillard_003c_16f628a.mpas,308 :: 		end
	GOTO       L__main144
;electronique_chenillard_003c_16f628a.mpas,309 :: 		else
L__main143:
;electronique_chenillard_003c_16f628a.mpas,311 :: 		FigureIdx := 1;
	MOVLW      1
	MOVWF      _FigureIdx+0
;electronique_chenillard_003c_16f628a.mpas,312 :: 		if bProgAuto then  // auto change prog
	MOVF       _bProgAuto+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main146
;electronique_chenillard_003c_16f628a.mpas,314 :: 		if ProgIdx < iProgCount then
	MOVLW      25
	SUBWF      _ProgIdx+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main149
;electronique_chenillard_003c_16f628a.mpas,315 :: 		inc(ProgIdx) // go to next set of figures
	INCF       _ProgIdx+0, 1
	GOTO       L__main150
;electronique_chenillard_003c_16f628a.mpas,316 :: 		else
L__main149:
;electronique_chenillard_003c_16f628a.mpas,317 :: 		ProgIdx := 1;
	MOVLW      1
	MOVWF      _ProgIdx+0
L__main150:
;electronique_chenillard_003c_16f628a.mpas,318 :: 		end;
L__main146:
;electronique_chenillard_003c_16f628a.mpas,319 :: 		end;
L__main144:
;electronique_chenillard_003c_16f628a.mpas,320 :: 		DataFigure := GetFigure;
	CALL       _GetFigure+0
	MOVF       R0+0, 0
	MOVWF      _DataFigure+0
;electronique_chenillard_003c_16f628a.mpas,321 :: 		PORTA.0 := DataFigure.0;
	BTFSC      _DataFigure+0, 0
	GOTO       L__main171
	BCF        PORTA+0, 0
	GOTO       L__main172
L__main171:
	BSF        PORTA+0, 0
L__main172:
;electronique_chenillard_003c_16f628a.mpas,322 :: 		PORTA.1 := DataFigure.1;
	BTFSC      _DataFigure+0, 1
	GOTO       L__main173
	BCF        PORTA+0, 1
	GOTO       L__main174
L__main173:
	BSF        PORTA+0, 1
L__main174:
;electronique_chenillard_003c_16f628a.mpas,323 :: 		PORTA.2 := DataFigure.2;
	BTFSC      _DataFigure+0, 2
	GOTO       L__main175
	BCF        PORTA+0, 2
	GOTO       L__main176
L__main175:
	BSF        PORTA+0, 2
L__main176:
;electronique_chenillard_003c_16f628a.mpas,324 :: 		PORTA.3 := DataFigure.3;
	BTFSC      _DataFigure+0, 3
	GOTO       L__main177
	BCF        PORTA+0, 3
	GOTO       L__main178
L__main177:
	BSF        PORTA+0, 3
L__main178:
;electronique_chenillard_003c_16f628a.mpas,325 :: 		PORTB.0 := DataFigure.4;
	BTFSC      _DataFigure+0, 4
	GOTO       L__main179
	BCF        PORTB+0, 0
	GOTO       L__main180
L__main179:
	BSF        PORTB+0, 0
L__main180:
;electronique_chenillard_003c_16f628a.mpas,326 :: 		PORTB.1 := DataFigure.5;
	BTFSC      _DataFigure+0, 5
	GOTO       L__main181
	BCF        PORTB+0, 1
	GOTO       L__main182
L__main181:
	BSF        PORTB+0, 1
L__main182:
;electronique_chenillard_003c_16f628a.mpas,327 :: 		PORTB.2 := DataFigure.6;
	BTFSC      _DataFigure+0, 6
	GOTO       L__main183
	BCF        PORTB+0, 2
	GOTO       L__main184
L__main183:
	BSF        PORTB+0, 2
L__main184:
;electronique_chenillard_003c_16f628a.mpas,328 :: 		PORTB.3 := DataFigure.7;
	BTFSC      _DataFigure+0, 7
	GOTO       L__main185
	BCF        PORTB+0, 3
	GOTO       L__main186
L__main185:
	BSF        PORTB+0, 3
L__main186:
;electronique_chenillard_003c_16f628a.mpas,329 :: 		iTimerCount := 0;
	CLRF       _iTimerCount+0
	CLRF       _iTimerCount+1
;electronique_chenillard_003c_16f628a.mpas,330 :: 		end;
L__main140:
;electronique_chenillard_003c_16f628a.mpas,331 :: 		end;
	GOTO       L__main135
;electronique_chenillard_003c_16f628a.mpas,332 :: 		end.
L_end_main:
	GOTO       $+0
; end of _main
